Re: [PATCH v2 3/4] bisect--helper: reimplement `bisect_run` shell function in C
From: Junio C Hamano <hidden>
Date: 2021-04-07 22:09:38
Miriam Rubio [off-list ref] writes:
From: Tanushree Tumane <redacted> Reimplement the `bisect_run()` shell function in C and also add `--bisect-run` subcommand to `git bisect--helper` to call it from git-bisect.sh. Mentored-by: Christian Couder [off-list ref] Signed-off-by: Tanushree Tumane <redacted> Signed-off-by: Miriam Rubio <redacted>
If I am reading the patch correctly, this removes the need for the
$GIT_DIR/BISECT_RUN file that used to be used to keep track of the
state? If that is true, it is worth noting in the proposed log
message.
As far as I can see, nobody creates $GIT_DIR/BISECT_RUN anymore.
$ git grep -e path_bisect_run -e BISECT_RUN
bisect.c:static GIT_PATH_FUNC(git_path_bisect_run, "BISECT_RUN")
bisect.c: unlink_or_warn(git_path_bisect_run());
builtin/bisect--helper.c: BISECT_RUN,
builtin/bisect--helper.c: N_("use <cmd>... to automatical...
builtin/bisect--helper.c: case BISECT_RUN:
t/t6030-bisect-porcelain.sh: test_path_is_missing ".git/BISECT_RUN" &&
What if a run script tried to read from (or checked the presence of)
the file for its correct operation (e.g. I would imagine that "do
this operation when run interactively, but do the same operation
silently when run from the git-bisect machinery" may be a reasonable
thing to do)?
This change just unintendedly broke such a script, didn't it? The
change makes me a bit worried.
+ if (bisect_next_check(terms, NULL))
+ return BISECT_FAILED;
+
+ if (argc)
+ sq_quote_argv(&command, argv);
+ else
+ return BISECT_FAILED;
+
+ run_args.v[0] = xstrdup(command.buf);
+ run_args.nr = 1;
+
+ while (1) {
+ strvec_clear(&args);
+
+ printf(_("running %s"), command.buf);
+ res = run_command_v_opt(run_args.v, RUN_USING_SHELL);Nicely used sq_quote_argv() with RUN_USING_SHELL here. Goodl.
+ if (res < 0 && res >= 128) {
+ error(_("bisect run failed: exit code %d from"
+ " '%s' is < 0 or >= 128"), res, command.buf);
+ strbuf_release(&command);
+ return res;
+ }
+
+ if (res == 125)
+ strvec_push(&args, "skip");
+ else if (res > 0)
+ strvec_push(&args, terms->term_bad);
+ else
+ strvec_push(&args, terms->term_good);
+bisect_state() does so much that it was a bit hard to follow for me (who hasn't been following the bisect-in-C topic very closely), but the code around here roughly corresponds to the following snippet in the original scripted version.
- git bisect--helper --bisect-state $state >"$GIT_DIR/BISECT_RUN" - res=$? - - cat "$GIT_DIR/BISECT_RUN" - - if sane_grep "first $TERM_BAD commit could be any of" "$GIT_DIR/BISECT_RUN" \ - >/dev/null - then - gettextln "bisect run cannot continue any more" >&2 - exit $res - fi
I see that the contents of the file BISECT_RUN is shown to the user in the original but is that part of what bisect_state() does, or did we lose it during this round of conversion?
+ res = bisect_state(terms, args.v, args.nr);
+ if (res == BISECT_INTERNAL_SUCCESS_MERGE_BASE) {
+ printf(_("bisect run success"));
+ res = BISECT_OK;
+ } else if (res == BISECT_ONLY_SKIPPED_LEFT)
+ error(_("bisect run cannot continue any more"));
+ else if (res)
+ error(_("bisect run failed:'git bisect--helper --bisect-state"
+ " %s' exited with error code %d"), args.v[0], res);
+ else
+ continue;In any case, being able to check the return value from bisect_state() and switch is so much nicer than having to sane_grep in BISECT_RUN.
quoted hunk
+ strbuf_release(&command); + strvec_clear(&args); + strvec_clear(&run_args); + + return res; + } +} + int cmd_bisect__helper(int argc, const char **argv, const char *prefix) { enum {@@ -1086,7 +1146,8 @@ int cmd_bisect__helper(int argc, const char **argv, const char *prefix) BISECT_LOG, BISECT_REPLAY, BISECT_SKIP, - BISECT_VISUALIZE + BISECT_VISUALIZE, + BISECT_RUN,
Now this new one has the trailing comma. I'd suggest doing so in the previous step. Thanks.